#ifndef CMS_PAGE_H
#define CMS_PAGE_H

#include "cms_err.h"
#include "cms_post.h"
#include <stddef.h>

typedef struct cms_page
{
	char* _str;
	char* title;
	char* slug;
	cms_post* posts;
	size_t numposts;
	struct cms_page* subs;
	size_t numsubs;
} cms_page;

cms_page* cms_page_create();

cms_err* cms_page_parse(cms_page* page, char* str, char* slugstr);

cms_err* cms_page_add_post(cms_page* page, cms_post* post);

cms_err* cms_page_add_sub(cms_page* page, cms_page* sub);

#endif
